'PHISCORE.BAS - hi score table for PTETRIS
'This file is chained from PTETRIS.BAS when game over
'Sc holds score from last game

Sc=Sc 'create variable if it doesn't exist (in case this program isn't chained)

Pause 2000 'give player chance to look at final state of Tetris

'temporarily save Sc to video memory
For i=0 To 3
  Poke RVIDEO, i, Peek(VAR Sc, i)
Next
Clear 'free up memory by clearing all variables hanging around from PTETRIS.BAS
Sc=0
'now recover value of Sc from video memory
For i=0 To 3
  Poke VAR Sc, i, Peek(RVIDEO, i)
Next
Mode 3:Colour 7,1:Font 2:Cls:Print@(60,25)"PTETRIS","High Scores"

f$="B:PHISCORE.DAT"
d$=Date$:ymd$=Right$(d$,4)+"-"+Mid$(d$,4,2)+"-"+Left$(d$,2)
num=15 'number of entries in hi score table

Open f$ For random As #1
If Lof(#1) <> num*30 Then
  Close#1:Kill f$:Open f$ For random As #1
  Randomize Timer
  For n=0 To num-1
    Print #1,"ceptimus  2019-07-13"Format$(n*4000+Int(4000*Rnd()),"%10.0f");
  Next
EndIf

Dim nm$(num-1),dt$(num-1),sc$(num-1),k(num-1)
ls=1E30:lowest=-1
For n=0 To num-1
  k(n)=n
  Seek #1,30*n+1
  nm$(n)=Input$(10,#1):dt$(n)=Input$(10,#1):sc$(n)=Input$(10,#1)
  s=Val(sc$(n)):If s<ls Then ls=s:lowest=n
Next
getName=0
If Sc>ls Then
  nm$(lowest)=Space$(10):sc$(lowest)=Format$(Sc,"%10.0f"):dt$(lowest)=ymd$
  getName=1
EndIf

'insertion sort (keys) by highest scores: for tied scores first date wins
Function less(a,b)
  less=Sgn(Val(sc$(k(a)))-Val(sc$(k(b))))
  If less=0 Then
    less = dt$(k(a))<dt$(k(b))
  ElseIf less<0 Then
    less = 0
  EndIf
End Function
For i=1 To num-1
  For j = i To 1 Step -1
    If less(j, j-1) <> 0 Then
      t=k(j):k(j)=k(j-1):k(j-1)=t
    Else
      Exit For
    EndIf
  Next
Next

Sub refresh()
  For i=0 To num-1
    If getName<>0 And k(i)=lowest Then
      getRow=i
      Colour 6,1
    Else
      Colour 7,1
    EndIf
    Print@(25,22*i+60)dt$(k(i))"  "nm$(k(i))" "sc$(k(i))
  Next
End Sub

getRow=0:refresh
If getName<>0 Then
  Colour 6,0:Print@(25+12*13,22*getRow+60)Space$(10)@(25+12*13,22*getRow+60);
  Do
    k=Asc(Inkey$)
  Loop Until k=0 'clear keyboard buffer
  Input"",a$:nm$(lowest)=Left$(a$+Space$(10),10)
  getName=0:refresh
  Seek #1, 30*lowest+1
  Print#1,nm$(lowest)ymd$sc$(lowest);
EndIf
Close #1
Colour 7,1:Print@(45,400)"P to play again or Esc to quit"
Do
  k=Asc(Inkey$)
  If k=27 Then
    Colour 7,0:Font 1:Cls:End
  EndIf
  If k=Asc("p") Or k=Asc("P") Then
    Clear:Run"PTETRIS.BAS"
  EndIf
Loop
