' PTETRIS.BAS - a Tetris for the Colour MaxiMite - Version 0.9
' by ceptimus July 2019 ceptimus@ceptimus.co.uk

Drive "B:":f$="PSPRITES.SPR":r$=Dir$(f$):If r$<>f$ Then Chain "B:PSPRITES.BAS"
Sprite Load f$
Clear:mp=1:mu$="A:PTETRIS.MOD":Option error continue:PlayMOD mu$

Data 22,23,24,33,12,23,34,35,13,22,23,24,11,12,23,34
Data 22,23,34,35,13,23,24,34,11,12,23,24,12,22,23,33
Data 33,34,35,36,13,24,35,46,22,23,24,25,12,23,34,45
Data 23,24,33,34,12,23,24,35,12,13,22,23,11,22,23,34
Data 22,23,24,34,12,23,24,34,12,22,23,24,12,22,23,34
Data 23,24,34,35,23,24,34,35,23,24,34,35,23,24,34,35
Data 22,23,24,35,12,13,23,34,11,22,23,24,12,23,33,34

Dim t(111):For i=0 To 111:Read t(i):Next

Data -1,0,-1,1,0,-2,-1,-2 'J,L,S,T,Z
Data 1,0,1,-1,0,2,1,2
Data 1,0,1,1,0,-2,1,-2
Data -1,0,-1,-1,0,2,-1,2
Data -2,0,1,0,-2,-1,1,2 'I
Data -1,0,2,0,-1,2,2,-1
Data 2,0,-1,0,2,1,-1,-2
Data 1,0,-2,0,1,-2,-2,1
Dim wk(63):For i=0 To 63:Read wk(i):Next

Sub drawTile(x, y, colr)
  Sprite paste 2*colr+1,x,y
  Sprite paste 2*colr+2,x,y+16
End Sub

Sub gravity(row)
  Local i
  BLIT pfx,pfy-359,pfx,pfy-341,150,18*(20-row)
  Line(pfx,pfy-359)-(pfx+149,pfy-342),0,BF
  For i=row*11 To 262:g(i)=g(i+11):Next
  For i=264 To 273:g(i)=0:Next
  For i=0 To 3:p(i)=p(i)-11:gp(i)=gp(i)-11:If gp(i)<0 Then gp(i)=0
  Next
  rmvc=rmvc-1
  For i=row To row+3
    If i>19 Then Exit For
    rmv(i)=rmv(i+1)
  Next
  rmv(i)=0
End Sub

Sub showPiece(p, x, y)
  Local i j
  For i=0 To 3
    j=t(p*16+i)
    drawTile(x+(j Mod 11)*15,y-(j\11)*18,p+1)
  Next
End Sub

Sub refreshPiece
  Local ic,in
  For in=0 To 3
    Do While ic<4
      If p(ic)<np(in) Then ic=ic+1 Else Exit Do
    Loop
    If ic>3 Then GoTo rp1
    If np(in)=p(ic) Then GoTo rp2
    rp1:
    If np(in)<230 Then
      drawTile(pfx+(np(in) Mod 11)*15,pfy-(np(in)\11)*18,pn+1)
    EndIf
    rp2:
  Next
  in=0
  For ic=0 To 3
    Do While in<4
      If np(in)<p(ic) Then in=in+1 Else Exit Do
    Loop
    If in>3 Then GoTo rp3
    If p(ic)=np(in) Then GoTo rp4
    rp3:
    If p(ic)>-1 And p(ic)<230 Then
      drawTile(pfx+(p(ic) Mod 11)*15,pfy-(p(ic)\11)*18,0)
    EndIf
    rp4:
  Next
  For in=0 To 3:p(in)=np(in):Next
End Sub

Function moveIfPossible(offset)
  Local i,j,noRoom
  For i=0 To 3:np(i)=rp(i)+offset:Next
  moveIfPossible=0
  For i=0 To 3
    If np(i)<0 Or np(i)>273 Then Exit For
    If g(np(i)) <> 0 Then Exit For
  Next
  If i=4 Then refreshPiece : pp=pp+offset:moveIfPossible=1
    gpp=pp
    For i=0 To 3:ng(i)=p(i):Next
    Do
      gpp=gpp-11:For i=0 To 3
        ng(i)=ng(i)-11:If ng(i)<11 Then noRoom=1:GoTo mip1
        If g(ng(i))<>0 Then noRoom=1
        mip1:
      Next
    Loop Until noRoom<>0
    gpp=gpp+11:For i=0 To 3:ng(i)=ng(i)+11:Next

    For i=0 To 3
      For j=0 To 3
        If ng(i)=p(j) Then ng(i)=0:Exit For
      Next
    Next

    For i=0 To 3
      For j=0 To 3
        If gp(i)=p(j) Then gp(i)=0:Exit For
      Next
    Next

    For i=0 To 3
      If gp(i)<230 And g(gp(i))=0 Then
        drawTile(pfx+(gp(i) Mod 11)*15,pfy-(gp(i)\11)*18,0)
      EndIf
    Next

    If gh<>0 Then
      For i=0 To 3
        If ng(i)<230 And g(ng(i))=0 Then
          Sprite paste 17, pfx+(ng(i) Mod 11)*15,pfy-(ng(i)\11)*18+1
        EndIf
      Next
    EndIf

    For i=0 To 3:gp(i)=ng(i):Next
  EndIf
End Function

Function rotateIfPossible(direction)
  Local npr,i,k,x,y
  rotateIfPossible = 1
  npr = pr+direction
  If npr>3 Then
    npr=0
  ElseIf npr<0 Then
    npr=3
  EndIf
  If pn=5 Then Exit Function 'square 'O' tetromino
  For i=0 To 3:rp(i)=pp+t(pn*16+npr*4+i):Next
  If moveIfPossible(0)<>0 Then pr=npr:Exit Function
  k=pr*8:If direction<0 Then k=npr*8
  If pn=2 Then k=k+32
  For i=0 To 3
    x=wk(k+i*2):y=wk(k+i*2+1)
    If direction<0 Then x=-x:y=-y
    If moveIfPossible(x+11*y) Then Exit For
  Next
  If i<4 Then pr=npr:Exit Function
  rotateIfPossible=0
End Function

sd=200:rd=100
ot=Timer:dl=sd
Function fik
  Local t,e,k$
  t=Timer:e=t-ot:ot=t:If e=0 Then e=1
  fik=KeyDown:If fik=0 Then dl=sd:Exit Function
  If dl=sd Then dl=dl-e:Exit Function
  dl=dl-e
  If dl>0 Then
    fik=0
  Else
    dl=dl+rd:If dl<0 Then dl=0
  EndIf
End Function

Sub checkKeyboard
  Local i,key
  key=Asc(Inkey$)
  If key<>0 Then
    If key=131 Then 'right
      For i=0 To 3:rp(i)=p(i):Next
      i=moveIfPossible(+1)
    ElseIf key=130 Then 'left
      For i=0 To 3:rp(i)=p(i):Next
      i=moveIfPossible(-1)
    ElseIf key=88 Or key=120 Or key=128 Then 'X,x,up
      i=rotateIfPossible(+1)
    ElseIf key=90 Or key=122 Then 'Z,z
      i=rotateIfPossible(-1)
    ElseIf key=129 Then 'down
      dropTime=Timer:score(1)
    ElseIf key=67 Or key=72 Or key=99 Or key=104 Then 'C,H,c,h
      If ha<>0 Then hf=1:dropTime=Timer
    ElseIf key=71 Or key=103 Then 'G,g
      gh=Not gh
    ElseIf key=77 Or key=109 Then 'M,m
      If mp=0 Then
        mp=1:PlayMOD mu$
      Else
        mp=0: PlayMOD STOP
      EndIf
    ElseIf key=80 Or key=112 Then 'P,p
      Font 1:Print@(pfx+9,pfy-372,1)"Paused - P to continue"
      Do
        key=Asc(Inkey$):If key=27 Then Chain "B:PHISCORE.BAS"
      Loop Until key=80 Or key=112
      dropTime=Timer+di
      Line(pfx+9,pfy-372)-(pfx+139,pfy-364),1,BF
    ElseIf key=32 Then
      For i=0 To 3:rp(i)=p(i):Next
      i=gpp-pp:If moveIfPossible(i)<>0 Then score(-i\11*2)
      dropTime=Timer
    ElseIf key=27 Then
      Chain "B:PHISCORE.BAS"
    EndIf
  EndIf
End Sub

Sub shuffle
  Local i,r,t
  For i=0 To 5:q(i+7)=q(i):Next
  For i=6 To 1 Step -1:r=Int(Rnd()*(i+1)):t=q(r):q(r)=q(i):q(i)=t:Next
End Sub

Function checkRow(row)
  Local i,er
  checkRow=0
  If row>20 Then Exit Function
  If rmv(row)<>0 Then Exit Function
  er=11*row+9
  For i=er-9 To er
    If g(i)=0 Then Exit For
  Next
  If i>er Then rmv(row)=1:rmvc=rmvc+1:checkRow=1
End Function

Sub score(p)
  Sc=Sc+p:Print@(92,390)Sc
End Sub

Dim g(274)
For i=0 To 10:g(i)=-1:Next
For i=21 To 274 Step 11:g(i)=-1:Next
Dim rmv(20):For i=0 To 20:rmv(i)=0:Next:rmvc=0
pfx=226:pfy=390:nbx=392:nby=318:hbx=nbx:hby=pfy
Mode 3:Colour 7,1:Cls:Font 2:Print@(60,25)"PTETRIS":m=30
Font 1:Print@(m+54,80)"Left: Left"@(m+48,95)"Right: Right"
Print@(m+24,110)"Clockwise: Up, X"@(m,125)"Anticlockwise: Z"
Print@(m+24,140)"Soft drop: down"@(m+24,155)"Hard drop: Space"
Print@(m+48,170)"Pause: P"@(m+54,185)"Hold: C,H"
Print@(m,200)" Toggle Ghost: G"@(m,215)" Toggle Music: M"
Print@(m+54,230)"Quit: Esc"
Line(pfx-2,pfy+2)-(pfx+150,pfy-360),7,BF
Line(pfx-1,pfy+1)-(pfx+149,pfy-360),0,BF
Line(nbx-2,nby+1)-(nbx+75,nby-288),7,BF
Line(nbx-1,nby+1)-(nbx+74,nby-288),0,BF
Line(hbx-2,hby+2)-(hbx+75,hby-54),7,BF
Line(hbx-1,hby+1)-(hbx+74,hby-53),0,BF
Randomize Timer:Dim q(12):For i=0 To 6:q(i)=i:Next
shuffle :shuffle
Dim p(3),rp(3),np(3)
Dim gp(3),ng(3)
For i=0 To 3:p(i)=-1:gp(i)=0:Next
qIndx=12
For i=8 To 12
  nx=q(i):x=nbx+15:If nx=2 Or nx=5 Then x=x-7
  showpiece(nx,x,nby-648+i*54)
Next

Dim pts(4):pts(0)=0:pts(1)=100:pts(2)=300:pts(3)=500:pts(4)=800
di=800:gh=1:hp=-1:hf=0
dropTime=Timer
Lv=1:Lns=0:Sc=0:Font 2:score(0):Print@(20,340)"Level:"@(92,340)0
Print@(20,365)"Lines:"@(92,365)0@(20,390)"Score:"
Do
  If hf<>0 Then
    ha=0
    i=hp:hp=pn:pn=i
    x=hbx+15:If hp=2 Or hp=5 Then x=x-7
    Line(hbx+8,hby-44)-(hbx+67,hby-9),0,BF:showPiece(hp,x,hby+10)
  EndIf
  If hf=0 Or i<0 Then
    ha=1
    pn=q(qIndx)
    BLIT nbx+7,nby-270,nbx+7,nby-216,60,198
    If qIndx=6 Then
      shuffle
      qIndx=12
    Else
      qIndx=qIndx-1
    EndIf
    nx=q(qIndx -4)
    x=nbx+15:If nx=2 Or nx=5 Then x=x-7
    Line(nbx+8,nby-270)-(nbx+67,nby-235),0,BF
    showPiece(nx,x,nby-216)
  EndIf
  pr=0:pp=212:If pn=2 Then pp=201
  For i=0 To 3
    rp(i)=pp+t(pn*16+pr*4+i)
  Next
  If moveIfPossible(0)=0 Then Chain "B:PHISCORE.BAS"
  hf=0
  Do 'till piece settles
    dropTime=dropTime+di
    Do While Timer<dropTime
      checkKeyboard
    Loop
    If hf<>0 Then Exit Do
    If rmvc<>0 Then 'at least one row to remove
      For row=1 To 20
        If rmv(row)<>0 Then gravity(row):Exit For
      Next
    EndIf
    For i=0 To 3:rp(i)=p(i):Next
    If moveIfPossible(-11)=0 Then 'settle and spawn
      rmvd=0
      For i=0 To 3
        g(p(i))=pn+1
        row=p(i)\11
        If checkRow(row)<>0 Then
          y=pfy-row*18+10
          Line(pfx,y-9)-(pfx+149,y-9),0
          For j=0 To 9
            Sprite paste 17, pfx+15*j,y-8
          Next
          rmvd=rmvd+1
        EndIf
        p(i)=-1
      Next
      If rmvd<>0 Then 'update score
        score(pts(rmvd)*Lv):Lns=Lns+rmvd:Print@(92,365)Lns
        If Lns\10<(Lns+rmvd)\10 Then Lv=Lv+1:Print@(92,340)Lv:di=Int(di*0.8)
      EndIf
      Exit Do
    EndIf
  Loop
Loop

